import { HeadersModel } from "./headers.model";
var OptionsModel = (function () {
    function OptionsModel() {
    }
    ;
    OptionsModel.build = function (obj) {
        var model = new OptionsModel();
        OptionsModel.setMethod(obj, model);
        OptionsModel.setMode(obj, model);
        OptionsModel.setCache(obj, model);
        OptionsModel.setCredentials(obj, model);
        model.headers = HeadersModel.build(obj.headers);
        OptionsModel.setRedirect(obj, model);
        OptionsModel.setReferrer(obj, model);
        if (obj.body) {
            model.body = obj.body;
        }
        return model;
    };
    OptionsModel.setMethod = function (obj, model) {
        OptionsModel.setter(obj, model, "method", "GET");
    };
    OptionsModel.setMode = function (obj, model) {
        OptionsModel.setter(obj, model, "mode", "same-origin");
    };
    OptionsModel.setCache = function (obj, model) {
        OptionsModel.setter(obj, model, "cache", "default");
    };
    OptionsModel.setCredentials = function (obj, model) {
        OptionsModel.setter(obj, model, "credentials", "same-origin");
    };
    OptionsModel.setRedirect = function (obj, model) {
        OptionsModel.setter(obj, model, "redirect", "follow");
    };
    OptionsModel.setReferrer = function (obj, model) {
        OptionsModel.setter(obj, model, "referrer", "client");
    };
    OptionsModel.setter = function (obj, model, key, defaultValue) {
        if (!obj[key]) {
            model[key] = defaultValue;
        }
        else {
            model[key] = obj[key];
        }
    };
    return OptionsModel;
}());
export { OptionsModel };
//# sourceMappingURL=options.model.js.map